HDU2444

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2444

题目大意:

  n个学生,他们中间有m对互相认识。有两个操作:

  1、把所有人分成两组,每组中的人都互不认识。若该操作能完成,那么请考虑操作2,否则输出“No”;

  2、将互相认识的两个人分配到一间双人房,问最多能分出多少间房。

  其实操作1就是要我们做一个二分图判定,我们用一个DFS就能完成,详见《挑战程序设计竞赛》P97。在确定这是一个二分图的前提下,我们就能根据学生之间的关系写一个匈牙利算法来求最大匹配数,最大匹配数其实就是最多的房间数。由于在程序中,我把每个房间当成了两个来进行匹配,所以最后的最大匹配数要除以2。

AC代码:

 1 #include <cstring>
 2 #include <vector>
 3 #include <cstdio>
 4 using namespace std;
 5 const int maxn=204;
 6 bool link[maxn][maxn], vis[maxn];
 7 int r[maxn],n,color[maxn];
 8 vector<int> G[maxn];
 9 bool finds(int x){
10     for(int i=1;i<=n;i++){
11         if(!vis[i]&&link[x][i]){
12             vis[i]=true;
13             if(r[i]==0||finds(r[i])){
14                 r[i]=x;
15                 return true;
16             }
17         }
18     }
19     return false;
20 }
21 bool dfs(int v,int c){
22     color[v]=c;
23     for(int i=0;i<G[v].size();i++){
24         if(color[G[v][i]]==c)   return false;
25         if(color[G[v][i]]==0&&!dfs(G[v][i],-c)) return false;
26     }
27     return true;
28 }
29 bool yes_no(){
30     for(int i=1;i<=n;i++){
31         if(color[i]==0){
32             if(!dfs(i,1))  return false;
33         }
34     }
35     return true;
36 }
37 int main(){
38     int m,a,b;
39     while(scanf("%d%d",&n,&m)==2){
40         memset(color,0,sizeof(color));
41         memset(link,false,sizeof(link));
42         memset(r,0,sizeof(r));
43         for(int i=1;i<=n;i++)   G[i].clear();
44         while(m--){
45             scanf("%d%d",&a,&b);
46             G[a].push_back(b),G[b].push_back(a);
47             link[a][b]=link[b][a]=true;
48         }
49         if(!yes_no()){
50             printf("No\n");
51             continue;
52         }
53         int ans=0;
54         for(int i=1;i<=n;i++){
55             memset(vis,false,sizeof(vis));
56             if(finds(i))    ans++;
57         }
58         printf("%d\n",ans/2);
59     }
60     return 0;
61 }
时间: 2024-12-15 06:30:28

HDU2444的相关文章

hdu2444 The Accomodation of Students(判断二分匹配+最大匹配)

//判断是否为二分图:在无向图G中,如果存在奇数回路,则不是二分图.否则是二分图. //判断回路奇偶性:把相邻两点染成黑白两色,如果相邻两点出现颜色相同则存在奇数回路.也就是非二分图. # include <stdio.h> # include <string.h> # include <algorithm> using namespace std; int vis[210],map[210][210],cott[210]; int c[210]; int flag,n

hdu2444 二分图的匹配,先判断是否为二分图

http://acm.hdu.edu.cn/showproblem.php?pid=2444 Problem Description There are a group of students. Some of them may know each other, while others don't. For example, A and B know each other, B and C know each other. But this may not imply that A and C

hdu2444二分图最大匹配+判断二分图

There are a group of students. Some of them may know each other, while others don't. For example, A and B know each other, B and C know each other. But this may not imply that A and C know each other. Now you are given all pairs of students who know

hdu2444(判二分图+最大匹配)

传送门:The Accomodation of Students 题意:有n个学生,m对相互认识的,问能否分成两队,使得每对中没有相互认识的,如果可以求最大匹配,否则输出No. 分析:判断二分图用染色法,然后直接匈牙利算法求最大匹配. #include <cstdio> #include <cstring> #include <string> #include <cmath> #include <iostream> #include <al

HDU2444(二分图判定+最大匹配)

The Accomodation of Students Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 4250    Accepted Submission(s): 1946 Problem Description There are a group of students. Some of them may know each ot

染色法判断是否是二分图 hdu2444

用染色法判断二分图是这样进行的,随便选择一个点, 1.把它染成黑色,然后将它相邻的点染成白色,然后入队列 2.出队列,与这个点相邻的点染成相反的颜色 根据二分图的特性,相同集合内的点颜色是相同的,即 但是如果这个图不是二分图,那么就会这样 把与1相邻的点2,3染成白色,然后入队列,然后2出队列,要把与2相邻的点2,3染成黑色,但是都染过了,所以不用染色 但是3的颜色应该与2相反(如果是二分图的话),可是没有相反,所以就不是二分图 1 #include <stdio.h> 2 #include

HDU2444 二分图

题意:有n个学生,他们之间可能互相认识.先判断是否可以分成两组,每组的学生互相都不认识,如果不能输出“No”.如果可以,每次从两组各拿出一个相互认识的学生组成一对,输出最多可以有多少对. 例如: 第一组数据: 4 4 1 2 1 3 1 4 2 3 由于1和其他所有学生都认识,而其它学生又有互相认识的,肯定不能分成两组了. 第二组数据: 6 5 1 2 1 3 1 4 2 5 3 6 可以分成下图的两组学生: 最多可找出(1,4)(2,5)(3,6)三对学生.

Hdu2444二分图

给你一个图,问是否为二分图,若是求出最大匹配. 并查集判图,原理黑白染色. #include <cstdio> #include <cstdlib> #include <cstring> #include <algorithm> #include <cmath> #include <stack> #include <queue> #include <vector> #include <map> #i

hdu2444 判断二分图+最大匹配

#include<stdio.h> #include<string.h> #include<queue> using namespace std; #define maxn 210 int map[maxn][maxn],color[maxn]; int vis[maxn],match[maxn],n; int bfs(int u,int n) { int i; queue<int>q; q.push(u); color[u]=1; while(!q.emp